/* FUSH - $VERSION$ 
* This file is part of FUSH (Free Unix SHell, Fine User SHell, or FU shell)
* based on Kyle Loudon code of Mastering Algorithms with C (O'reilly) fame.
*  (great job by the way)
* 2/29/02
* Author:  Cory Marsh
* Contact: cmarsh@idahopower.com
*/

#ifndef LIST_H
#define LIST_H

#include <stdlib.h>
#include <sys/types.h>

/* Basic list element: pointer to data, pointer to next data */
typedef struct ListElmt_ {
    void *data;
    struct ListElmt_ *next;
} ListElmt;

/* Basic linked list */
typedef struct List_ {
    int size;
    int (*match) (const void *key1, const void *key2);
    void (*destroy) (void *data);
    ListElmt *head;
    ListElmt *tail;
} List;

/* standard prototypes */
void list_init(List * list, void (*destroy) (void *data));
void list_destroy(List * list);
int list_ins_next(List * list, ListElmt * element, const void *data);
int list_rem_next(List * list, ListElmt * element, void **data);

/* define some data members for easy refrence */
#define list_size(list) ((list)->size)
#define list_head(list) ((list)->head)
#define list_tail(list) ((list)->tail)
#define list_is_head(list, element) ((element == (list)->head ? 1 : 0)
#define list_is_tail(element) ((element)->next == NULL ? 1 : 0)
#define list_data(element) ((element)->data)
#define list_next(element) ((element)->next)

#endif      /* list_h */
